/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.extractors;

import it.eng.spago4q.extractors.bo.ExtractorParameter;
import it.eng.spago4q.extractors.xml.SaxXmlExtractor;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import junit.framework.TestCase;

public class AbstractExtractorTest extends TestCase {


	private AbstractExtractor extractor;

	public AbstractExtractorTest(final String value) {
		super(value);
	}


	@Override
	protected void setUp() throws Exception {
		super.setUp();
			List<ExtractorParameter> iDataSourceParameters = new ArrayList<ExtractorParameter>();
			iDataSourceParameters.add(new ExtractorParameter("DSPAR","1"));
			iDataSourceParameters.add(new ExtractorParameter("DSPAR","2"));
			
			List<ExtractorParameter> iOperationParameters = new ArrayList<ExtractorParameter>();
			iOperationParameters.add(new ExtractorParameter("OPAR", "a"));
			iOperationParameters.add(new ExtractorParameter("OPAR", "b"));
			iOperationParameters.add(new ExtractorParameter("OPAR", "c"));
			// Create the extractor
			extractor = new SaxXmlExtractor();
			extractor.init(iDataSourceParameters, iOperationParameters);

	}

	public void testReadDataSourceParameterValueList() {
		// Check the number of Data Source parameters
		assertEquals(2, extractor.getDataSourceParameter().size());
		
		List<String> dsPars = extractor.readDataSourceParameterValueList("DSPAR");

		assertEquals(2, dsPars.size());

		Integer value = 1;
		for (Iterator iterator = dsPars.iterator(); iterator.hasNext();) {
			assertEquals(value.toString(),(String) iterator.next());
			value ++;
		}
	}

	public void testReadOperationParameterValueList() {
		assertEquals(3, extractor.getOperationParameter().size());

		List<String> oPars = extractor.readOperationParameterValueList("OPAR"); 
		assertEquals(3, oPars.size());
		
		Character value = 'a';
		for (Iterator iterator = oPars.iterator(); iterator.hasNext();) {
			assertEquals(value.toString(),(String) iterator.next());
			value ++;
		}
	}
}
